## ns3 3.7.1

=== nsc-0.5.1/SConstruct ===
# vim: filetype=python

#  Network Simulation Cradle
#  Copyright (C) 2003-2005 Sam Jansen
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2 of the License, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
#  more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc., 59
#  Temple Place, Suite 330, Boston, MA 02111-1307 USA

# Doesn't work? Had problems using timestamp signatures. Might have sped things
# up...
#SourceSignatures('timestamp')


Help("""
     use 'scons libstackname.so' to built a specific stack.
     use 'scons target=arch' to specify target architecture (either amd64 or x86).
     Default target architecture is autodetect.
     """)

# We use newer SCons versions and naming, need at least 1.0 to build. Scons
# 1.0.1 is included locally, just use "python scons.py".
EnsureSConsVersion(1,0)

def get_target_architecture(context):
    import os
    def get_elf_class(filename):
        file = open(str(filename))
        data = file.read(5)
        file.close()
        # Valid ELF header?
        if data[0] == '\x7f' and data[1] == 'E' and data[2] == 'L' and data[3] == 'F':
            if data[4] == '\x01':
                return 'x86'
            elif data[4] == '\x02':
                return 'amd64'
            raise TypeError, "Unknown ELF class"
        else:
            raise TypeError, "%s: not in ELF format" % filename

    target = ARGUMENTS.get('target')
    # allow user to override using scons target=(amd64|x86)
    if target:
        context.Result('Target set to %s on command line, check skipped' % target)
        os.environ['NSC_TARGET_ARCHITECTURE'] = target
        return target
    arch = os.uname()[4]
    context.Message('Checking target architecure...')
    if arch == 'i686' or arch == 'i586' or arch == 'i486' or arch == 'i386':
        result = 'x86'
    elif arch == 'x86_64':
        source = 'int main(void)\n{return 0;}\n'
        context.Message('amd64, checking userland ...')
        result = context.TryCompile(source, '.c')
        if not result:
            return result
        result = get_elf_class(context.lastTarget)
    else:
        raise OSError, ('Unsupported architecture, if you want to '
                        'crosscompile, use \"scons target=x86\" (or amd64)')

    context.Result(result)
    context.env['NSC_TARGET_ARCHITECTURE'] = result
    return result

def filter_globalised(target, source, env):
  """Used by the globaliser builder to remove already globalised files.

  This is required because the suffix for globalised files is still the same as
  the original files (both have .c at the end). We use '.globalised.c' to
  indicate files that have been globalised, so if the source has this string in
  it, we return empty lists to inform SCons that there is no action to be
  taken.
  """
  if len(source) > 1 or len(target) > 1:
    return ([], [])
  if str(source[0]).find('.globalised.') != -1:
    return ([], [])
  env.Depends(target, '#' + env['GLOBALISER'])
  return (target, source)

# -----------------------------------------------------------------------------
# The globaliser action is configured as follows:
#   single_source=True -- This means that if the action is given a list of
#     source files, it will be invoked once for each source file
#   emitter=filter_globalised -- This filtered out alread-globalised files. See
#     the docstring of filter_globalised
#   source_scanner=SourceFileScanner -- Use the default scanner to find
#     dependencies of the source files. This means that the source list will go
#     through the normal C dependency scanning.
globaliser_action = '$CC $CCFLAGS $GLB_CCFLAGS $_CPPDEFFLAGS $_CPPINCFLAGS ' \
    + ' -E $SOURCE -o - | $GLOBALISER $GLB_FLAGS $GLB_LIST >$TARGET'
globaliser_builder = Builder(action=globaliser_action,
                             src_suffix='.c',
                             suffix='.globalised.c',
                             single_source=True,
                             emitter=filter_globalised,
                             source_scanner=SourceFileScanner)

# -----------------------------------------------------------------------------
# Site-local customisation: load a custom.py (if it exists), and allow
# overriding the C and C++ compilers. This allows the user to e.g. specify a
# cross-compiler to compile in 32-bit mode on a 64-bit machine.
vars = Variables('custom.py')
vars.AddVariables(
    ('CC', 'The default C compiler used'),
    ('CXX', 'The default C++ compiler user'),
    ('LINKFLAGS', 'Extra arguments passed to the linker'),
    )

# -----------------------------------------------------------------------------
# Run the configure tests and build the environment
env = Environment(variables=vars)
conf = Configure(env, custom_tests={
      'get_target_architecture': get_target_architecture})
if not conf.get_target_architecture():
    Exit(1)
env = conf.Finish()

# -----------------------------------------------------------------------------
# 'default_env' is exported, it is expected that all SConscript files import
# this environment and Clone it.
default_env = env.Clone(GLOBALISER='globaliser/globaliser', GLB_FLAGS='')
default_env.Append(BUILDERS={'Globaliser': globaliser_builder})
Export('default_env')

# -----------------------------------------------------------------------------
# The list of SConscript files to read in.
SConscript('globaliser/SConscript')

SConscript('freebsd5/SConscript')
SConscript('lwip-HEAD/src/SConscript')
SConscript('openbsd3/SConscript')

SConscript('linux-2.6/SConscript')
SConscript("linux-2.6.18/SConscript")
SConscript("linux-2.6.26/SConscript")

SConscript('test/SConscript')

=== pybindgen-0.12.0.710/wscript ===
## -*- python -*-
## (C) 2007,2008 Gustavo J. A. M. Carneiro

import Options
import Build
import Scripting

import Configure
Configure.autoconfig = True
import Logs

#from Params import fatal

import os
import pproc as subprocess
import shutil
import sys
import Configure
import tarfile
import re
import types

import Task
Task.file_deps = Task.extract_deps


APPNAME='pybindgen'
srcdir = '.'
blddir = 'build'



## Add the pybindgen dir to PYTHONPATH, so that the examples and tests are properly built before pybindgen is installed.
os.environ['PYTHONPATH'] = os.getcwd()


def _get_version_from_bzr_lib(path):
    import bzrlib.tag, bzrlib.branch
    fullpath = os.path.abspath(path)
    if sys.platform == 'win32':
        fullpath = fullpath.replace('\\', '/')
        fullpath = '/' + fullpath
    branch = bzrlib.branch.Branch.open('file://' + fullpath)
    tags = bzrlib.tag.BasicTags(branch)
    #print "Getting version information from bzr branch..."
    history = branch.revision_history()
    history.reverse()
    ## find closest tag
    version = None
    extra_version = []
    for revid in history:
        #print revid
        for tag_name, tag_revid in tags.get_tag_dict().iteritems():
            if tag_revid == revid:
                #print "%s matches tag %s" % (revid, tag_name)
                version = [int(s) for s in tag_name.split('.')]
                ## if the current revision does not match the last
                ## tag, we append current revno to the version
                if tag_revid != branch.last_revision():
                    extra_version = [branch.revno()]
                break
        if version:
            break
    assert version is not None
    _version = version + extra_version
    return _version


def _get_version_from_bzr_command(path):
    # get most recent tag first
    most_recent_tag = None
    proc = subprocess.Popen(['bzr', 'log', '--short'], stdout=subprocess.PIPE)
    reg = re.compile('{([0-9]+)\.([0-9]+)\.([0-9]+)}')
    for line in proc.stdout:
        result = reg.search(line)
        if result is not None:
            most_recent_tag = [int(result.group(1)), int(result.group(2)), int(result.group(3))]
            break
    proc.stdout.close()
    proc.wait()
    assert most_recent_tag is not None
    # get most recent revno
    most_recent_revno = None
    proc = subprocess.Popen(['bzr', 'revno'], stdout=subprocess.PIPE)
    most_recent_revno = int(proc.stdout.read().strip())
    proc.wait()
    version = most_recent_tag + [most_recent_revno]
    return version
    

_version = None
def get_version_from_bzr(path):
    global _version
    if _version is not None:
        return _version
    try:
        import bzrlib.tag, bzrlib.branch
    except ImportError:
        return _get_version_from_bzr_command(path)
    else:
        return _get_version_from_bzr_lib(path)

    
def get_version(path=None):
    if path is None:
        path = srcdir
    try:
        return '.'.join([str(x) for x in get_version_from_bzr(path)])
    except ImportError:
        return 'unknown'

def generate_version_py(force=False, path=None):
    """generates pybindgen/version.py, unless it already exists"""

    filename = os.path.join('pybindgen', 'version.py')
    if not force and os.path.exists(filename):
        return

    if path is None:
        path = srcdir
    version = get_version_from_bzr(path)
    dest = open(filename, 'w')
    if isinstance(version, list):
        dest.write('__version__ = %r\n' % (version,))
        dest.write('"""[major, minor, micro, revno], '
                   'revno omitted in official releases"""\n')
    else:
        dest.write('__version__ = "%s"\n' % (version,))
    dest.close()
    

def dist_hook():
    blddir = '../build'
    srcdir = '..'
    version = get_version(srcdir)
    subprocess.Popen([os.path.join(srcdir, "generate-ChangeLog")],  shell=True).wait()
    try:
        os.chmod(os.path.join(srcdir, "ChangeLog"), 0644)
    except OSError:
        pass
    shutil.copy(os.path.join(srcdir, "ChangeLog"), '.')

    ## Write a pybindgen/version.py file containing the project version
    generate_version_py(force=True, path=srcdir)

    ## Copy it to the source dir
    shutil.copy(os.path.join('pybindgen', 'version.py'), os.path.join(srcdir, "pybindgen"))

    ## Copy WAF to the distdir
    #assert os.path.basename(sys.argv[0]) == 'waf'
    shutil.copy(os.path.join(srcdir, sys.argv[0]), '.')

    ## Package the api docs in a separate tarball
    apidocs = 'apidocs'
    if not os.path.isdir('apidocs'):
        Logs.warn("Not creating apidocs archive: the `apidocs' directory does not exist")
    else:
        tar = tarfile.open(os.path.join("..", "pybindgen-%s-apidocs.tar.bz2" % version), 'w:bz2')
        tar.add('apidocs', "pybindgen-%s-apidocs" % version)
        tar.close()
        shutil.rmtree('apidocs', True)

    ## This is a directory I usually keep in my tree -- gjc
    shutil.rmtree('pybindgen-google-code', True)

    shutil.rmtree('.shelf', True)

    try:
        os.unlink('waf-light')
    except OSError:
        pass


def set_options(opt):
    opt.tool_options('python')
    opt.tool_options('compiler_cc')
    opt.tool_options('compiler_cxx')
    opt.tool_options('cflags')

    optgrp = opt.add_option_group("PyBindGen Options")

    if os.path.isdir(".bzr"):
        optgrp.add_option('--generate-version',
                          help=('Generate a new pybindgen/version.py file from version control'
                                ' introspection.  Only works from a bzr checkout tree, and is'
                                ' meant to be used by pybindgen developers only.'),
                          action="store_true", default=False,
                          dest='generate_version')

    optgrp.add_option('--examples',
                      help=('Compile the example programs.'),
                      action="store_true", default=False,
                      dest='examples')

    optgrp.add_option('--disable-pygccxml',
                      help=('Disable pygccxml for unit tests / examples.'),
                      action="store_true", default=False,
                      dest='disable_pygccxml')

def configure(conf):

    def _check_compilation_flag(conf, flag):
        """
        Checks if the C++ compiler accepts a certain compilation flag or flags
        flag: can be a string or a list of strings
        """

        env = conf.env.copy()
        env.append_value('CXXFLAGS', flag)
        try:
            retval = conf.run_c_code(code='#include <stdio.h>\nint main() { return 0; }\n',
                                     env=env, compile_filename='test.cc',
                                     compile_mode='cxx',type='cprogram', execute=False)
        except Configure.ConfigurationError:
            ok = False
        else:
            ok = (retval == 0)
        conf.check_message_custom(flag, 'support', (ok and 'yes' or 'no'))
        return ok

    conf.check_compilation_flag = types.MethodType(_check_compilation_flag, conf)

    ## Write a pybindgen/version.py file containing the project version
    generate_version_py()

    conf.check_tool('command')
    conf.check_tool('python')
    conf.check_python_version((2,3))

    try:
        conf.check_tool('compiler_cc')
        conf.check_tool('compiler_cxx')
    except Configure.ConfigurationError:
        Logs.warn("C/C++ compiler not detected.  Unit tests and examples will not be compiled.")
        conf.env['CXX'] = ''
    else:
        conf.check_tool('cflags')
        conf.check_python_headers()

        if not Options.options.disable_pygccxml:
            gccxml = conf.find_program('gccxml')
            if not gccxml:
                conf.env['ENABLE_PYGCCXML'] = False
            else:
                try:
                    conf.check_python_module('pygccxml')
                except Configure.ConfigurationError:
                    conf.env['ENABLE_PYGCCXML'] = False
                else:
                    conf.env['ENABLE_PYGCCXML'] = True

        # -fvisibility=hidden optimization
        if (conf.env['CXX_NAME'] == 'gcc' and [int(x) for x in conf.env['CC_VERSION']] >= [4,0,0]
            and conf.check_compilation_flag('-fvisibility=hidden')):
            conf.env.append_value('CXXFLAGS_PYEXT', '-fvisibility=hidden')
            conf.env.append_value('CCFLAGS_PYEXT', '-fvisibility=hidden')


def build(bld):
    global g_bld
    g_bld = bld
    if getattr(Options.options, 'generate_version', False):
        generate_version_py(force=True)

    bld.add_subdirs('pybindgen')
    if Options.options.examples:
        bld.add_subdirs('examples')
    if Options.commands['check'] or Options.commands['clean']:
        bld.add_subdirs('tests')

check_context = Build.BuildContext
def check(bld):
    "run the unit tests"
    Scripting.build(bld)
    print "Running pure python unit tests..."
    retval1 = subprocess.Popen([Build.bld.env['PYTHON'], 'tests/test.py']).wait()

    env = g_bld.env

    if env['CXX']:
        print "Running manual module generation unit tests (module foo)..."
        retval2 = subprocess.Popen([env['PYTHON'], 'tests/footest.py', '1']).wait()
    else:
        print "Skipping manual module generation unit tests (no C/C++ compiler)..."
        retval2 = 0

    if env['ENABLE_PYGCCXML']:
        print "Running automatically scanned module generation unit tests (module foo2)..."
        retval3 = subprocess.Popen([env['PYTHON'], 'tests/footest.py', '2']).wait()

        print "Running module generated by automatically generated python script unit tests (module foo3)..."
        retval3b = subprocess.Popen([env['PYTHON'], 'tests/footest.py', '3']).wait()

        print "Running module generated by generated and split python script unit tests  (module foo4)..."
        retval3c = subprocess.Popen([env['PYTHON'], 'tests/footest.py', '4']).wait()

        print "Running semi-automatically scanned c-hello module ('hello')..."
        retval4 = subprocess.Popen([env['PYTHON'], 'tests/c-hello/hellotest.py']).wait()
    else:
        print "Skipping automatically scanned module generation unit tests (pygccxml missing)..."
        print "Skipping module generated by automatically generated python script unit tests (pygccxml missing)..."
        print "Skipping module generated by generated and split python script unit tests  (pygccxml missing)..."
        print "Skipping semi-automatically scanned c-hello module (pygccxml missing)..."
        retval3 = retval3b = retval3c = retval4 = 0

    if retval1 or retval2 or retval3 or retval3b or retval3c or retval4:
        Logs.error("Unit test failures")
        raise SystemExit(2)


def generate_api_docs(ctx):
    "generate API documentation, using epydoc"
    generate_version_py(force=True)
    retval = subprocess.Popen(["epydoc", "-v", "--html", "--graph=all",  "pybindgen",
                               "-o", "apidocs",
                               "--pstat=build/foomodulegen-auto.pstat",
                                   "--pstat=build/foomodulegen.pstat",
                               "--pstat=build/hellomodulegen.pstat",
                               "--no-private",
                               ]).wait()
    if retval:
        Logs.error("epydoc returned with code %i" % retval)
        raise SystemExit(2)

    # Patch the generated CSS file to highlight literal blocks (this is a copy of pre.py-doctest)
    css = open("apidocs/epydoc.css", "at")
    css.write("""
pre.literalblock {  padding: .5em; margin: 1em;
                    background: #e8f0f8; color: #000000;
                    border: 1px solid #708890; }
""")
    css.close()

=== ns-3.7.1/samples/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    env = bld.env_of_name('default')
    if not env['ENABLE_EXAMPLES']:
        return;

    obj = bld.create_ns3_program('main-attribute-value')
    obj.source = 'main-attribute-value.cc'

    obj = bld.create_ns3_program('main-callback')
    obj.source = 'main-callback.cc'

    obj = bld.create_ns3_program('main-simulator')
    obj.source = 'main-simulator.cc'

    obj = bld.create_ns3_program('main-ptr')
    obj.source = 'main-ptr.cc'

    obj = bld.create_ns3_program('main-random-variable')
    obj.source = 'main-random-variable.cc'

    obj = bld.create_ns3_program('main-packet-header', ['common', 'simulator'])
    obj.source = 'main-packet-header.cc'

    obj = bld.create_ns3_program('main-packet-tag', ['common', 'simulator'])
    obj.source = 'main-packet-tag.cc'

    if bld.env['ENABLE_THREADING'] and bld.env["ENABLE_REAL_TIME"]:
        obj = bld.create_ns3_program('main-test-sync')
        obj.source = 'main-test-sync.cc'

    obj = bld.create_ns3_program('main-simple',
                                 ['node', 'internet-stack', 'onoff'])
    obj.source = 'main-simple.cc'

    obj = bld.create_ns3_program('main-grid-topology',
                                 ['core', 'simulator', 'mobility', 'internet-stack'])
    obj.source = 'main-grid-topology.cc'

    obj = bld.create_ns3_program('main-random-topology',
                                 ['core', 'simulator', 'mobility'])
    obj.source = 'main-random-topology.cc'
    
    obj = bld.create_ns3_program('main-random-walk',
                                 ['core', 'simulator', 'mobility'])
    obj.source = 'main-random-walk.cc'

    obj = bld.create_ns3_program('main-propagation-loss',
                                 ['core', 'simulator', 'mobility', 'wifi'])
    obj.source = 'main-propagation-loss.cc'

    obj = bld.create_ns3_program('main-ns2-mob',
                                 ['core', 'simulator', 'mobility', 'wifi'])
    obj.source = 'main-ns2-mob.cc'

    obj = bld.create_ns3_program('sample-random-variable',
                                 ['core', 'simulator'])
    obj.source = 'sample-random-variable.cc'

=== ns-3.7.1/src/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

import os, os.path
import shutil
import types
import warnings

import TaskGen
import Task
import Options
import Build
import Utils

all_modules = (
    'core',
    'common',
    'simulator',
    'contrib',
    'node',
    'internet-stack',
    'devices/point-to-point',
    'devices/csma',
    'devices/emu',
    'devices/bridge',
    'devices/tap-bridge',
    'devices/virtual-net-device',
    'applications/onoff',
    'applications/packet-sink',
    'applications/udp-echo',
    'routing/nix-vector-routing',
    'routing/olsr',
    'routing/global-routing',
    'routing/static-routing',
    'routing/list-routing',
    'routing/aodv',
    'mobility',
    'devices/wifi',
    'helper',
    'contrib/stats',
    'applications/v4ping',
    'devices/mesh',
    'devices/mesh/dot11s',
    'devices/mesh/flame',
    'applications/ping6',
    'applications/radvd',
    'test',
    'test/ns3tcp',
    'test/ns3wifi',
    'contrib/flow-monitor',
    'applications/udp-client-server',
    )

def set_options(opt):
    opt.sub_options('simulator')

    opt.add_option('--enable-rpath',
                   help=("Link programs with rpath"
                         " (normally not needed, see "
                         " --run and --shell; moreover, only works in some"
                         " specific platforms, such as Linux and Solaris)"),
                   action="store_true", dest='enable_rpath', default=False)
    
    opt.add_option('--enable-modules',
                   help=("Build only these modules (and dependencies)"),
                   dest='enable_modules')

def configure(conf):
    conf.sub_config('core')
    conf.sub_config('simulator')
    conf.sub_config('devices/emu')
    conf.sub_config('devices/tap-bridge')
    conf.sub_config('contrib')
    conf.sub_config('internet-stack')
    conf.sub_config('helper')

    blddir = os.path.abspath(os.path.join(conf.blddir, conf.env.variant()))
    conf.env.append_value('NS3_MODULE_PATH', blddir)
    if Options.options.enable_rpath:
        conf.env.append_value('RPATH', '-Wl,-rpath=%s' % (os.path.join(blddir),))

    ## Used to link the 'test-runner' program with all of ns-3 code
    conf.env['NS3_MODULES'] = ['ns3-' + module.split('/')[-1] for module in all_modules]


def create_ns3_module(bld, name, dependencies=()):
    module = bld.new_task_gen('cxx')
    module.name = 'ns3-' + name
    module.target = module.name
    module.add_objects = ['ns3-' + dep for dep in dependencies]
    module.module_deps = list(dependencies)
    if not module.env['ENABLE_STATIC_NS3']:
        module.env.append_value('CXXFLAGS', module.env['shlib_CXXFLAGS'])
    elif module.env['CXX_NAME'] in ['gcc', 'icc'] and \
            os.uname()[4] == 'x86_64' and \
            module.env['ENABLE_PYTHON_BINDINGS']:
        # enable that flag for static builds only on x86-64 platforms
        # when gcc is present and only when we want python bindings
        # (it's more efficient to not use this option if we can avoid it)
        module.env.append_value('CXXFLAGS', '-mcmodel=large')
        
    module.env.append_value('CXXDEFINES', "NS3_MODULE_COMPILATION")
    return module

def create_obj(bld, *args):
    warnings.warn("(in %s) Use bld.new_task_gen(...) now, instead of bld.create_obj(...)" % str(bld.path),
                  DeprecationWarning, stacklevel=2)
    return bld.new_task_gen(*args)

def build(bld):
    bld.create_ns3_module = types.MethodType(create_ns3_module, bld)
    bld.create_obj = types.MethodType(create_obj, bld)
    
    bld.add_subdirs(list(all_modules))

    for module in all_modules:
        modheader = bld.new_task_gen('ns3moduleheader')
        modheader.module = module.split('/')[-1]


class ns3header_taskgen(TaskGen.task_gen):
    """A set of NS-3 header files"""
    COLOR = 'BLUE'
    def __init__(self, *args, **kwargs):
        super(ns3header_taskgen, self).__init__(*args, **kwargs)
        self.install_path = None
        self.sub_dir = None # if not None, header files will be published as ns3/sub_dir/file.h
        self.module = None # module name

    def apply(self):
        if self.module is None:
            raise Utils.WafError("'module' missing on ns3headers object %s" % self)
        ns3_dir_node = self.bld.path.find_dir("ns3")
        if self.sub_dir is not None:
            ns3_dir_node = ns3_dir_node.find_dir(self.sub_dir)
        for filename in self.to_list(self.source):
            src_node = self.path.find_resource(filename)
            if src_node is None:
                raise Utils.WafError("source ns3 header file %s not found" % (filename,))
            dst_node = ns3_dir_node.find_or_declare(os.path.basename(filename))
            assert dst_node is not None
            task = self.create_task('ns3header', self.env)
            task.set_inputs([src_node])
            task.set_outputs([dst_node])

class ns3header_task(Task.Task):
    before = 'cc cxx gen_ns3_module_header_task'
    color = 'BLUE'
    def run(self):
        assert len(self.inputs) == len(self.outputs)
        inputs = [node.srcpath(self.env) for node in self.inputs]
        outputs = [node.bldpath(self.env) for node in self.outputs]
        for src, dst in zip(inputs, outputs):
            try:
                os.chmod(dst, 0600)
            except OSError:
                pass
            shutil.copy2(src, dst)
            ## make the headers in builddir read-only, to prevent
            ## accidental modification
            os.chmod(dst, 0400)
        return 0



class gen_ns3_module_header_task(Task.Task):
    before = 'cc cxx'
    after = 'ns3header_task'
    color = 'BLUE'
    def run(self):
        assert len(self.outputs) == 1
        header_files = [os.path.basename(node.abspath(self.env)) for node in self.inputs]
        outfile = file(self.outputs[0].bldpath(self.env), "w")
        header_files.sort()

        print >> outfile, """
#ifdef NS3_MODULE_COMPILATION
# error "Do not include ns3 module aggregator headers from other modules; these are meant only for end user scripts."
#endif

#ifndef NS3_MODULE_%s
    """ % (self.module.upper().replace('-', '_'),)

    #     if self.module_deps:
    #         print >> outfile, "// Module dependencies:"
    #     for dep in self.module_deps:
    #         print >> outfile, "#include \"%s-module.h\"" % dep

        print >> outfile
        print >> outfile, "// Module headers:"
        for header in header_files:
            print >> outfile, "#include \"%s\"" % (header,)

        print >> outfile, "#endif"

        outfile.close()
        return 0

    def sig_explicit_deps(self):
        m = Utils.md5()
        m.update('\n'.join([node.abspath(self.env) for node in self.inputs]))
        return m.digest()

    def unique_id(self):
        try:
            return self.uid
        except AttributeError:
            "this is not a real hot zone, but we want to avoid surprizes here"
            m = Utils.md5()
            m.update("ns-3-module-header-%s" % self.module)
            self.uid = m.digest()
            return self.uid


class ns3moduleheader_taskgen(TaskGen.task_gen):
    """
    Generates a 'ns3/foo-module.h' header file that includes all
    public ns3 headers of a certain module.
    """
    COLOR = 'BLUE'
    def __init__(self, *args, **kwargs):
        super(ns3moduleheader_taskgen, self).__init__(*args, **kwargs)

    def apply(self):
        ## get all of the ns3 headers
        ns3_dir_node = self.bld.path.find_dir("ns3")
        all_headers_inputs = []
        found_the_module = False
        for ns3headers in self.bld.all_task_gen:
            if isinstance(ns3headers, ns3header_taskgen):
                if ns3headers.module != self.module:
                    continue
                found_the_module = True
                for source in ns3headers.to_list(ns3headers.source):
                    source = os.path.basename(source)
                    node = ns3_dir_node.find_or_declare(os.path.basename(source))
                    if node is None:
                        fatal("missing header file %s" % (source,))
                    all_headers_inputs.append(node)
        if not found_the_module:
            raise Utils.WscriptError("error finding headers for module %s" % self.module)
        if not all_headers_inputs:
            return
        module_obj = self.bld.name_to_obj("ns3-" + self.module, self.env)
        assert module_obj is not None
        all_headers_outputs = [ns3_dir_node.find_or_declare("%s-module.h" % self.module)]
        task = self.create_task('gen_ns3_module_header', self.env)
        task.set_inputs(all_headers_inputs)
        task.set_outputs(all_headers_outputs)
        task.module = self.module
        task.module_deps = module_obj.module_deps

    def install(self):
        pass

=== ns-3.7.1/utils/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
import os.path

def build(bld):
    env = bld.env

    test_runner = bld.create_ns3_program('test-runner', ['core'])
    test_runner.install_path = None # do not install
    test_runner.source = 'test-runner.cc'
    test_runner.uselib_local = 'ns3'
    
    obj = bld.create_ns3_program('bench-simulator', ['simulator'])
    obj.source = 'bench-simulator.cc'

    obj = bld.create_ns3_program('bench-packets', ['common'])
    obj.source = 'bench-packets.cc'

    obj = bld.create_ns3_program('print-introspected-doxygen',
                                 ['internet-stack', 'csma-cd', 'point-to-point'])
    obj.source = 'print-introspected-doxygen.cc'

=== pybindgen-0.12.0.710/tests/wscript ===
## -*- python -*-
#import Action
#import Object
#import Params
import Task

import sys
import os.path
import os
import pproc as subprocess

# uncomment to enable profiling information
# epydoc uses the profile data to generate call graphs
#os.environ["PYBINDGEN_ENABLE_PROFILING"] = ""


if 0:
    DEPRECATION_ERRORS = '-Werror::DeprecationWarning' # deprecations become errors
else:
    DEPRECATION_ERRORS = '-Wdefault::DeprecationWarning' # normal python behaviour


def build(bld):
    env = bld.env

    env['TOP_SRCDIR'] = bld.srcnode.abspath()

    gen = bld.new_task_gen(
        features='command',
        source='test-generation.py',
        target='test.cc',
        command='${PYTHON} ${SRC[0]} ${TOP_SRCDIR} > ${TGT[0]}')

    if env['CXX']:
        obj = bld.new_task_gen(features='cxx pyext')
        obj.source = 'test.cc'
        if env['CXX_NAME'] == 'gcc':
            obj.env.append_value('CXXFLAGS', ['-Werror', '-Wno-unused'])
    
    ## manual code generation using simple pybindgen API calls
    bindgen = bld.new_task_gen(
        features='command',
        source='foomodulegen.py',
        target='foomodule.cc',
        command='${PYTHON} %s ${SRC[0]} ${TOP_SRCDIR} > ${TGT[0]}' % (DEPRECATION_ERRORS,))

    if env['CXX']:
        obj = bld.new_task_gen(features='cxx cshlib pyext')
        obj.source = [
            'foo.cc',
            'foomodule.cc'
            ]
        obj.target = 'foo'
        obj.install_path = None
        obj.includes = '.'

    ## automatic code scanning using gccxml
    if env['ENABLE_PYGCCXML']:
        ### Same thing, but using gccxml autoscanning

        bld.new_task_gen(
            features='command',
            source='foomodulegen-auto.py foo.h',
            target='foomodule2.cc foomodulegen_generated.py',
            command='${PYTHON} %s ${SRC[0]} ${SRC[1]} ${cpp_path_repr} ${TGT[1]} > ${TGT[0]}' % (DEPRECATION_ERRORS,),
            variables=dict(cpp_path_repr=repr(bindgen.env['CPPPATH_PYEXT'])))

        obj = bld.new_task_gen(features='cxx cshlib pyext')
        obj.source = [
            'foo.cc',
            'foomodule2.cc'
            ]
        obj.target = 'foo2'
        obj.install_path = None
        obj.includes = '.'

        ### Now using the generated python script

        bld.new_task_gen(
            features='command',
            source='foomodulegen3.py foomodulegen_generated.py',
            target='foomodule3.cc',
            command='${PYTHON} %s ${SRC[0]} ${TGT[0]} > ${TGT[0]}' % (DEPRECATION_ERRORS,))

        ## yes, this global manipulation of PYTHONPATH is kind of evil :-/
        ## TODO: add WAF command-output support for customising command OS environment
        os.environ["PYTHONPATH"] = os.pathsep.join([os.environ.get("PYTHONPATH", ''), bindgen.path.abspath(bindgen.env)])

        obj = bld.new_task_gen(features='cxx cshlib pyext')
        obj.source = [
            'foo.cc',
            'foomodule3.cc'
            ]
        obj.target = 'foo3'
        obj.install_path = None # do not install
        obj.includes = '.'

        ## ---

        bld.new_task_gen(
            features='command',
            source='foomodulegen-auto-split.py foo.h',
            target='foomodulegen_split.py foomodulegen_module1.py foomodulegen_module2.py',
            command='${PYTHON} %s ${SRC[0]} ${SRC[1]} ${cpp_path_repr} ${TGT[0]} ${TGT[1]} ${TGT[2]}' % (DEPRECATION_ERRORS,),
            variables=dict(cpp_path_repr=repr(bindgen.env['CPPPATH_PYEXT'])))

        bld.new_task_gen(
            features='command',
            source=[
                'foomodulegen4.py',
                'foomodulegen_split.py',
                'foomodulegen_module1.py',
                'foomodulegen_module2.py',
                ],
            target=[
                'foomodule4.cc',
                'foomodule4.h',
                'foomodulegen_module1.cc',
                'foomodulegen_module2.cc',
                ],
            command='${PYTHON} %s ${SRC[0]} ${TGT[0]}' % (DEPRECATION_ERRORS,))


        obj = bld.new_task_gen(features='cxx cshlib pyext')
        obj.source = [
            'foo.cc',
            'foomodule4.cc',
            'foomodulegen_module1.cc',
            'foomodulegen_module2.cc',
            ]
        obj.target = 'foo4'
        obj.install_path = None # do not install
        obj.includes = '.'

    ## pure C tests
    bld.add_subdirs('c-hello')

=== ns-3.7.1/bindings/python/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

import re
import os
import pproc as subprocess
import shutil
import sys

import Task
import Options
import Configure
import TaskGen
import Logs
import Build
import Utils

## https://launchpad.net/pybindgen/
REQUIRED_PYBINDGEN_VERSION = (0, 12, 0, 710)
REQUIRED_PYGCCXML_VERSION = (0, 9, 5)


def add_to_python_path(path):
    if os.environ.get('PYTHONPATH', ''):
        os.environ['PYTHONPATH'] = path + os.pathsep + os.environ.get('PYTHONPATH')
    else:
        os.environ['PYTHONPATH'] = path

def set_pybindgen_pythonpath(env):
    if env['WITH_PYBINDGEN']:
        add_to_python_path(env['WITH_PYBINDGEN'])


def set_options(opt):
    opt.tool_options('python')
    opt.add_option('--disable-python',
                   help=("Don't build Python bindings."),
                   action="store_true", default=False,
                   dest='python_disable')
    opt.add_option('--python-scan',
                   help=("Rescan Python bindings.  Needs working GCCXML / pygccxml environment."),
                   action="store_true", default=False,
                   dest='python_scan')
    opt.add_option('--with-pybindgen',
                   help=('Path to an existing pybindgen source tree to use.'),
                   default=None,
                   dest='with_pybindgen', type="string")


def configure(conf):
    conf.env['ENABLE_PYTHON_BINDINGS'] = False
    if Options.options.python_disable:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "disabled by user request")
        return

    conf.check_tool('misc')

    if sys.platform == 'cygwin':
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "unsupported platform 'cygwin'")
        Logs.warn("Python is not supported in CygWin environment.  Try MingW instead.")
        return

    ## Check for Python
    try:
        conf.check_tool('python')
        conf.check_python_version((2,3))
        conf.check_python_headers()
    except Configure.ConfigurationError, ex:
        conf.report_optional_feature("python", "Python Bindings", False, str(ex))
        return

    # -fvisibility=hidden optimization
    if (conf.env['CXX_NAME'] == 'gcc' and [int(x) for x in conf.env['CC_VERSION']] >= [4,0,0]
        and conf.check_compilation_flag('-fvisibility=hidden')):
        conf.env.append_value('CXXFLAGS_PYEXT', '-fvisibility=hidden')
        conf.env.append_value('CCFLAGS_PYEXT', '-fvisibility=hidden')

    # Check for the location of pybindgen
    if Options.options.with_pybindgen is not None:
        if os.path.isdir(Options.options.with_pybindgen):
            conf.check_message("pybindgen location", '', True, ("%s (given)" % Options.options.with_pybindgen))
            conf.env['WITH_PYBINDGEN'] = os.path.abspath(Options.options.with_pybindgen)
    else:
        pybindgen_dir = os.path.join('..', "pybindgen")
        if os.path.isdir(pybindgen_dir):
            conf.check_message("pybindgen location", '', True, ("%s (guessed)" % pybindgen_dir))
            conf.env['WITH_PYBINDGEN'] = os.path.abspath(pybindgen_dir)
        del pybindgen_dir
    if not conf.env['WITH_PYBINDGEN']:
        conf.check_message("pybindgen location", '', False)

    # Check for pybindgen

    set_pybindgen_pythonpath(conf.env)

    try:
        conf.check_python_module('pybindgen')
    except Configure.ConfigurationError:
        Logs.warn("pybindgen missing => no python bindings")
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "PyBindGen missing")
        return
    else:
        out = subprocess.Popen([conf.env['PYTHON'], "-c",
                                "import pybindgen.version; "
                                "print '.'.join([str(x) for x in pybindgen.version.__version__])"],
                                stdout=subprocess.PIPE).communicate()[0]
        pybindgen_version_str = out.strip()
        pybindgen_version = tuple([int(x) for x in pybindgen_version_str.split('.')])
        conf.check_message('pybindgen', 'version',
                           (pybindgen_version == REQUIRED_PYBINDGEN_VERSION),
                           pybindgen_version_str)
        if not (pybindgen_version == REQUIRED_PYBINDGEN_VERSION):
            Logs.warn("pybindgen (found %s), (need %s)" %
                    (pybindgen_version_str,
                     '.'.join([str(x) for x in REQUIRED_PYBINDGEN_VERSION])))
            conf.report_optional_feature("python", "Python Bindings", False,
                                         "PyBindGen version not correct and newer version could not be retrieved")
            return


    def test(t1, t2):
        test_program = '''
#include <stdint.h>
#include <vector>

int main ()
{
   std::vector< %(type1)s > t = std::vector< %(type2)s > ();
   return 0;
}
''' % dict(type1=t1, type2=t2)

        try:
            ret = conf.run_c_code(code=test_program,
                                  env=conf.env.copy(), compile_filename='test.cc',
                                  compile_mode='cxx',type='cprogram', execute=False)
        except Configure.ConfigurationError:
            ret = 1
        conf.check_message_custom('types %s and %s' % (t1, t2), 'equivalency', (ret and 'no' or 'yes'))
        return not ret

    uint64_is_long = test("uint64_t", "unsigned long")
    uint64_is_long_long = test("uint64_t", "unsigned long long")

    if uint64_is_long:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = 'gcc-LP64'
    elif uint64_is_long_long:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = 'gcc-ILP32'
    else:
        conf.env['PYTHON_BINDINGS_APIDEFS'] = None
    if conf.env['PYTHON_BINDINGS_APIDEFS'] is None:
        msg = 'none available'
    else:
        msg = conf.env['PYTHON_BINDINGS_APIDEFS']

    conf.check_message_custom('the apidefs that can be used for Python bindings', '', msg)

    if conf.env['PYTHON_BINDINGS_APIDEFS'] is None:
        conf.report_optional_feature("python", "Python Bindings", False,
                                     "No apidefs are available that can be used in this system")
        return

    ## If all has gone well, we finally enable the Python bindings
    conf.env['ENABLE_PYTHON_BINDINGS'] = True
    conf.report_optional_feature("python", "Python Bindings", True, None)

    

    ## Check for pygccxml
    try:
        conf.check_python_module('pygccxml')
    except Configure.ConfigurationError:
        conf.report_optional_feature("pygccxml", "Python API Scanning Support", False,
                                     "Missing 'pygccxml' Python module")
        return

    out = subprocess.Popen([conf.env['PYTHON'], "-c",
                            "import pygccxml; print pygccxml.__version__"],
                            stdout=subprocess.PIPE).communicate()[0]
    pygccxml_version_str = out.strip()
    pygccxml_version = tuple([int(x) for x in pygccxml_version_str.split('.')])
    conf.check_message('pygccxml', 'version',
                       (pygccxml_version >= REQUIRED_PYGCCXML_VERSION),
                       pygccxml_version_str)
    if not (pygccxml_version >= REQUIRED_PYGCCXML_VERSION):
        Logs.warn("pygccxml (found %s) is too old (need %s) => "
                "automatic scanning of API definitions will not be possible" %
                (pygccxml_version_str,
                 '.'.join([str(x) for x in REQUIRED_PYGCCXML_VERSION])))
        conf.report_optional_feature("pygccxml", "Python API Scanning Support", False,
                                     "pygccxml too old")
        return
    

    ## Check gccxml version
    gccxml = conf.find_program('gccxml', var='GCCXML')
    if not gccxml:
        Logs.warn("gccxml missing; automatic scanning of API definitions will not be possible")
        conf.report_optional_feature("pygccxml", "Python API Scanning Support", False,
                                     "gccxml missing")
        return

    gccxml_version_line = os.popen(gccxml + " --version").readline().strip()
    m = re.match( "^GCC-XML version (\d\.\d(\.\d)?)$", gccxml_version_line)
    gccxml_version = m.group(1)
    gccxml_version_ok = ([int(s) for s in gccxml_version.split('.')] >= [0, 9])
    conf.check_message('gccxml', 'version', True, gccxml_version)
    if not gccxml_version_ok:
        Logs.warn("gccxml too old, need version >= 0.9; automatic scanning of API definitions will not be possible")
        conf.report_optional_feature("pygccxml", "Python API Scanning Support", False,
                                     "gccxml too old")
        return
    
    ## If we reached
    conf.env['ENABLE_PYTHON_SCANNING'] = True
    conf.report_optional_feature("pygccxml", "Python API Scanning Support", True, None)


prio_headers = {
    -2: (
        "string.h", # work around http://www.gccxml.org/Bug/view.php?id=6682
        ),
    -1: (
        "propagation-delay-model.h",
        "propagation-loss-model.h",
        "net-device.h",
        "ipv4-interface.h",
        )
     }

def get_header_prio(header):
    for prio, headers in prio_headers.iteritems():
        if header in headers:
            return prio
    return 1


def calc_header_include(path):
    (head, tail) = os.path.split (path)
    if tail == 'ns3':
        return ''
    else:
        return os.path.join (calc_header_include (head), tail)


class gen_everything_h_task(Task.Task):
    before = 'cc cxx'
    after = 'ns3header_task'
    color = 'BLUE'

    def run(self):
        assert len(self.outputs) == 1

        header_files = [calc_header_include(node.abspath(self.env)) for node in self.inputs]
        outfile = file(self.outputs[0].bldpath(self.env), "w")

        def sort_func(h1, h2):
            return cmp((get_header_prio(h1), h1), (get_header_prio(h1), h2))

        header_files.sort(sort_func)

        print >> outfile, """

/* http://www.nsnam.org/bugzilla/show_bug.cgi?id=413 */
#ifdef ECHO
# undef ECHO
#endif

    """
        for header in header_files:
            print >> outfile, "#include \"ns3/%s\"" % (header,)

        print >> outfile, """
namespace ns3 {
static inline Ptr<Object>
__dummy_function_to_force_template_instantiation (Ptr<Object> obj, TypeId typeId)
{
   return obj->GetObject<Object> (typeId);
}


static inline void
__dummy_function_to_force_template_instantiation_v2 ()
{
   Time t1, t2, t3;
   t1 = t2 + t3;
   t1 = t2 - t3;
   TimeSquare tsq = t2*t3;
   Time tsqdiv = tsq/Seconds(1);
   Scalar scal = t2/t3;
   TimeInvert inv = scal/t3;
   t1 = scal*t1;
   t1 = t1/scal;
   t1 < t2;
   t1 <= t2;
   t1 == t2;
   t1 != t2;
   t1 >= t2;
   t1 > t2;
}


}
"""
        outfile.close()
        return 0



class all_ns3_headers_taskgen(TaskGen.task_gen):
    """Generates a 'everything.h' header file that includes some/all public ns3 headers.
    This single header file is to be parsed only once by gccxml, for greater efficiency.
    """
    def __init__(self, *args, **kwargs):
        super(all_ns3_headers_taskgen, self).__init__(*args, **kwargs)
        self.install_path = None
        #self.inst_dir = 'ns3'

    def apply(self):
        ## get all of the ns3 headers
        ns3_dir_node = self.bld.path.find_dir("ns3")
        all_headers_inputs = []

        for filename in self.to_list(self.source):
            src_node = ns3_dir_node.find_or_declare(filename)
            if src_node is None:
                raise Utils.WafError("source ns3 header file %s not found" % (filename,))
            all_headers_inputs.append(src_node)

        ## if self.source was empty, include all ns3 headers in enabled modules
        if not all_headers_inputs:
            for ns3headers in self.bld.all_task_gen:
                if type(ns3headers).__name__ == 'ns3header_taskgen': # XXX: find less hackish way to compare
                    ## skip headers not part of enabled modules
                    if self.env['NS3_ENABLED_MODULES']:

=== ns-3.7.1/doc/manual/Makefile ===
TEXI2HTML = texi2html
TEXI2PDF = texi2dvi --pdf
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert
CSS = --css-include=manual.css
SPLIT = --split section

FIGURES = figures
DOC_FIGURES = ..
VPATH = $(FIGURES)

IMAGES_EPS = \
	$(FIGURES)/internet-node-send.eps \
	$(FIGURES)/internet-node-recv.eps \
	$(FIGURES)/packet.eps \
	$(FIGURES)/node.eps \
	$(FIGURES)/buffer.eps \
	$(FIGURES)/sockets-overview.eps \
	$(FIGURES)/software-organization.eps \
	$(FIGURES)/routing.eps \
	$(FIGURES)/routing-specialization.eps \
	$(FIGURES)/testbed.eps \
	$(FIGURES)/emulated-channel.eps \
	$(FIGURES)/snir.eps \
	$(DOC_FIGURES)/WifiArchitecture.eps

IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

CHAPTERS = \
	manual.texi \
	animation.texi \
	attributes.texi \
	bridge.texi \
	callbacks.texi \
	csma.texi \
	emulation.texi \
	emu.texi \
	flow-monitor.texi \
	helpers.texi \
	internet.texi \
	ipv4.texi \
	ipv6.texi \
	log.texi \
	manual.texi \
	mesh.texi \
	names.texi \
	new-models.texi \
	node.texi \
	objects.texi \
	other.texi \
	output.texi \
	packets.texi \
	point-to-point.texi \
	python.texi \
	random.texi \
	realtime.texi \
	routing.texi \
	simple.texi \
	sockets.texi \
	statistics.texi \
	tap.texi \
	tcp.texi \
	tracing.texi \
	troubleshoot.texi \
	wifi.texi

%.eps : %.dia; $(DIA) -t eps $< -e $@
%.png : %.dia; $(DIA) -t png $< -e $@
%.pdf : %.eps; $(EPSTOPDF) $< -o=$@

all:  $(IMAGES) version manual.pdf manual.html manual/manual.html

manual.pdf: version $(IMAGES) $(CHAPTERS)
	$(TEXI2PDF) manual.texi

manual.html: version $(IMAGES) $(CHAPTERS)
	$(TEXI2HTML) ${CSS} manual.texi

manual/manual.html: version $(IMAGES) $(CHAPTERS)
	$(TEXI2HTML) ${CSS} ${SPLIT} --output manual manual.texi

figures-clean:
	rm -rf $(IMAGES)

version:
	echo -n "ns-" > VERSION-PREFIX; cat VERSION-PREFIX ../../VERSION > VERSION; rm -rf VERSION-PREFIX

texi-clean: 	
	rm -rf manual.aux manual.cp manual.cps manual.fn manual.ky manual.pg manual.tp
	rm -rf manual.vr manual.toc manual.log manual.pdf manual.html manual/ VERSION 

clean:	figures-clean texi-clean

=== ns-3.7.1/doc/testing/Makefile ===
TEXI2HTML = texi2html
TEXI2PDF = texi2dvi --pdf
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert
CSS = --css-include=testing.css
SPLIT = --split section

FIGURES = figures
VPATH = $(FIGURES)

IMAGES_EPS = \

IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}

IMAGES = $(IMAGES_EPS) $(IMAGES_PNG) $(IMAGES_PDF)

CHAPTERS = \
	testing.texi \
	overview.texi \
	background.texi \
	testing-framework.texi \
	how-to-write-tests.texi \
	validation.texi \
	random-variables.texi \
	propagation-loss.texi \
	references.texi \

%.eps : %.dia; $(DIA) -t eps $< -e $@
%.png : %.dia; $(DIA) -t png $< -e $@
%.pdf : %.eps; $(EPSTOPDF) $< -o=$@

all:  $(IMAGES) version testing.pdf testing.html testing/testing.html

testing.pdf: version $(IMAGES) $(CHAPTERS)
	$(TEXI2PDF) testing.texi

testing.html: version $(IMAGES) $(CHAPTERS)
	$(TEXI2HTML) ${CSS} testing.texi

testing/testing.html: version $(IMAGES) $(CHAPTERS)
	$(TEXI2HTML) ${CSS} ${SPLIT} --output testing testing.texi

figures-clean:
	rm -rf $(IMAGES)

version:
	echo -n "ns-" > VERSION-PREFIX; cat VERSION-PREFIX ../../VERSION > VERSION; rm -rf VERSION-PREFIX

clean: 	figures-clean
	rm -rf testing.aux testing.cp testing.cps testing.fn testing.ky testing.pg 
	rm -rf testing.tp testing.vr testing.toc testing.log testing.pdf testing.html testing/ VERSION missfont.log

=== ns-3.7.1/doc/tutorial/Makefile ===
TEXI2HTML = texi2html
TEXI2PDF = texi2dvi --pdf
EPSTOPDF = epstopdf
DIA = dia
CONVERT = convert
CSS = --css-include=tutorial.css
SPLIT = --split section

DIA_SOURCES = pp.dia dumbbell.dia star.dia 

DIA_EPS = ${DIA_SOURCES:.dia=.eps}
DIA_PNG = ${DIA_SOURCES:.dia=.png}
DIA_PDF = ${DIA_SOURCES:.dia=.pdf}

all:  html split-html pdf

# Note:  tgif requires a valid x display to convert from .obj to .png.  
#        If running this makefile on a remote console, the X virtual frame
#        buffer may be needed (xorg-x11-server-Xvfb) to provide a "fake"
#        display
images:
	cd figures/; $(DIA) -t png $(DIA_SOURCES) 
	cd figures/; $(DIA) -t eps $(DIA_SOURCES) 
	cd figures/; $(foreach FILE,$(DIA_EPS),$(EPSTOPDF) $(FILE);)

html: 
	$(TEXI2HTML) ${CSS} tutorial.texi

split-html: 
	$(TEXI2HTML) ${CSS} ${SPLIT} --output tutorial tutorial.texi

pdf:
	$(TEXI2PDF) tutorial.texi

figures-clean:
	cd figures/; rm -rf $(DIA_EPS); rm -rf $(DIA_PNG); rm -rf $(DIA_PDF)

clean: # figures-clean
	rm -rf tutorial.aux tutorial.cp tutorial.cps tutorial.fn tutorial.ky tutorial.pg tutorial.tp tutorial.vr tutorial.toc tutorial.log tutorial.pdf tutorial.html tutorial/

=== ns-3.7.1/examples/error-model/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('simple-error-model', ['point-to-point', 'internet-stack'])
    obj.source = 'simple-error-model.cc'

=== ns-3.7.1/examples/ipv6/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_program('icmpv6-redirect', ['csma', 'internet-stack'])
    obj.source = 'icmpv6-redirect.cc'

    obj = bld.create_ns3_program('ping6', ['csma', 'internet-stack'])
    obj.source = 'ping6.cc'
    
    obj = bld.create_ns3_program('radvd', ['csma', 'internet-stack'])
    obj.source = 'radvd.cc'

    obj = bld.create_ns3_program('radvd-two-prefix', ['csma', 'internet-stack'])
    obj.source = 'radvd-two-prefix.cc'

    obj = bld.create_ns3_program('test-ipv6', ['point-to-point', 'internet-stack'])
    obj.source = 'test-ipv6.cc'
    
    obj = bld.create_ns3_program('fragmentation-ipv6', ['csma', 'internet-stack'])
    obj.source = 'fragmentation-ipv6.cc'

    obj = bld.create_ns3_program('loose-routing-ipv6', ['csma', 'internet-stack'])
    obj.source = 'loose-routing-ipv6.cc'

=== debian/changelog ===
ns3 (3.7.1-7) unstable; urgency=low

  * Initial release (Closes: #574471)

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 18 Mar 2010 21:28:35 +0800

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 3.8.4
Maintainer: YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), quilt (>= 0.46-7~), pkg-config, libsqlite3-dev, python-all-dev, python-support, texi2html, texinfo, imagemagick, dia, ghostscript, texlive-font-utils, texlive-latex-base, texlive-generic-recommended
Vcs-git: git://github.com/wzssyqa/ns3-debian.git
Vcs-Browser: http://github.com/wzssyqa/ns3-debian
Homepage: http://www.nsnam.org/

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use.
 .
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 

Package: ns3-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: documentation for ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 .
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains manual, testing, tutorial.

Package: libns3-3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: shared library files of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 .
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains shared library files.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libdevel
Description: develop files of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 .
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains develop files.

Package: python-ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Provides: ${python:Provides}
Section: python
Description: develop files of ns3
 ns-3 is a discrete-event network simulator for Internet systems, 
 targeted primarily for research and educational use. 
 ns-3 is free software, licensed under the GNU GPLv2 license, 
 and is publicly available for research, development, and use. 
 ns-3 is intended as an eventual replacement for the popular
 .
 ns-2 simulator. The project acronym “nsnam” derives 
 historically from the concatenation of ns (network simulator) 
 and nam (network animator). 
 .
 This package contains python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f

NS3_DIR=ns-3.7.1
PYBINDGENV_DIR=pybindgen-0.12.0.710
REFTRACE_DIR=ns-3.7.1-ref-traces
NSC_DIR=nsc-0.5.1

PYVERS=$(shell pyversions -s)

%:
	dh $@ --with quilt


override_dh_auto_configure:
	cd $(NS3_DIR);./waf configure --doxygen-no-build --disable-examples -d release \
		--prefix=/usr --regression-tests= --with-regression-traces=../$(REFTRACE_DIR) \
		--with-pybindgen=../$(PYBINDGENV_DIR) --with-nsc=../$(NSC_DIR)
#		--enable-mpi


override_dh_auto_build:
	make all -C ./$(NS3_DIR)/doc/manual/
	make all -C ./$(NS3_DIR)/doc/testing/
	make all -C ./$(NS3_DIR)/doc/tutorial/

	cd $(NS3_DIR);./waf build
	
#	cd $(NS3_DIR);./waf check  #bug 798 makes it check failed http://www.nsnam.org/bugzilla/show_bug.cgi?id=798

override_dh_auto_install:
	################################################ ns3
	cd ./$(NS3_DIR);./waf install --destdir=../debian/ns3
	if [ ! -d ./debian/ns3/usr/share/doc/ns3 ] ;then mkdir -p ./debian/ns3/usr/share/doc/ns3 ;fi
	cp ./$(NS3_DIR)/RELEASE_NOTES ./debian/ns3/usr/share/doc/ns3
	cp ./$(NS3_DIR)/README ./debian/README.source
	rm ./debian/ns3/usr/lib/libns3.so
	################################################ libns3-3
	mkdir -p ./debian/libns3-3/usr/lib
	mv ./debian/ns3/usr/lib/libns3.so.3 ./debian/libns3-3/usr/lib
	mv ./debian/ns3/usr/lib/libns3.so.3.7.1 ./debian/libns3-3/usr/lib

	################################################ ns3-doc	
	mkdir -p ./debian/tmp/ns3-doc
	
	cp ./$(NS3_DIR)/doc/manual/manual.pdf ./$(NS3_DIR)/doc/manual/manual.html ./debian/tmp/ns3-doc
	cp -r ./$(NS3_DIR)/doc/manual/manual ./debian/tmp/ns3-doc

	
	cp  ./$(NS3_DIR)/doc/testing/testing.pdf ./$(NS3_DIR)/doc/testing/testing.html ./debian/tmp/ns3-doc
	cp -r ./$(NS3_DIR)/doc/testing/testing ./debian/tmp/ns3-doc

	cp ./$(NS3_DIR)/doc/tutorial/tutorial.pdf ./$(NS3_DIR)/doc/tutorial/tutorial.html ./debian/tmp/ns3-doc
	cp -r ./$(NS3_DIR)/doc/tutorial/tutorial ./debian/tmp/ns3-doc
	cp ./$(NS3_DIR)/doc/build.txt ./$(NS3_DIR)/doc/codingstd.txt ./$(NS3_DIR)/doc/contributing.txt ./$(NS3_DIR)/doc/mercurial.txt ./$(NS3_DIR)/doc/modules ./$(NS3_DIR)/doc/release_steps.txt ./debian/tmp/ns3-doc
	################################################ libns3-dev
	mkdir -p ./debian/tmp/libns3-dev/	
	cp -r ./$(NS3_DIR)/build/release/ns3 ./debian/tmp/libns3-dev/
	find ./$(NS3_DIR)/build/release/src -name '*.o' -exec cp -n {} ./debian/tmp/libns3-dev/ \;
	ar r debian/tmp/libns3-dev/libns3.a debian/tmp/libns3-dev/*.o
	ranlib debian/tmp/libns3-dev/libns3.a
	cp -r ns-3.7.1/examples debian/tmp/libns3-dev/
	find debian/tmp/libns3-dev/examples -name 'waf' -exec rm {} \;
	############################################### python-ns3
	for pyv in $(PYVERS);\
	do \
		mkdir -p ./debian/python-ns3/usr/lib/$(pyv)/dist-packages/ ;\
		mv ./debian/ns3/usr/lib/_ns3.so ./debian/python-ns3/usr/lib/$(pyv)/dist-packages/ ;\
		cp debian/ns3.py ./debian/python-ns3/usr/lib/$(pyv)/dist-packages ;\
	done
	############################################### other clean
	rmdir ./debian/ns3/usr/lib/
	
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs ./$(NS3_DIR)/CHANGES.html

=== debian/watch ===
version=3
http://www.nsnam.org/releases/ns-allinone-([\d.]+)\.tar\.bz2
